#ifndef ESPUTIL_H
#define ESPUTIL_H

// ===================================================
// espUtil.h: Utility functions used for the esp8266 communication, such as the AT-Commands, etc.
// ===================================================

#define SSID String("[Your SSID]")
#define PWD  String("[Your Password]")

SoftwareSerial esp8266(11,12);    // RX, TX

boolean sendCmd(String cmd, char* expectedAnswer)
{
  esp8266.println(cmd);
  if(esp8266.findUntil(expectedAnswer, "ERROR"))
  {
    return true;
  }
  else
  {
    Serial.println("ESP SEND ERROR: " + cmd);
    return false;
  }
}

String sendCmd(String cmd)
{
  esp8266.println(cmd);
  return esp8266.readString();
}

void serialDebug()
{
  while(true)
  {
    if(esp8266.available())
      Serial.write(esp8266.read());
    if(Serial.available())
      esp8266.write(Serial.read());
  }
}

boolean espConfig()
{
  boolean success = true;
  esp8266.setTimeout(20000);
  success &= sendCmd("AT", "OK");
  esp8266.setTimeout(1000);
  
  
  success &= sendCmd("AT+CWMODE=1", "OK");  
  
  

  return success;
}

boolean configStation()
{
  boolean success = true;
  esp8266.setTimeout(15000);
  success &= sendCmd("AT+CWDHCP=1,1", "OK");
  success &= sendCmd("AT+CWJAP=\"" + SSID + "\",\"" + PWD + "\"","OK");  
  esp8266.setTimeout(1500);
  //success &= sendCmd("AT+CIPMODE=0", "OK");
  success &= sendCmd("AT+CIPMUX=1", "OK");
  return success;
  
}

boolean configTcpServer() {
  boolean success = true;
  success &= sendCmd("AT+CIPMUX=1","OK");
  success &= sendCmd("AT+CIPSERVER=1,80","OK");

  return success;
}

boolean configTcpClient() {
  boolean success = true;
  success &= sendCmd("AT+CIPMUX=0","OK");

  return success;
}





#endif
