#ifndef RGB_H
#define RGB_H

// ===================================================
// rgb.h: Utillity functions, used to switch single RGB-LED colors on or off.
// We use a parallel connection of two neighboring pins, so that we have a total output impedance of 1/2*20KR.
// Therefore it is crucial to switch two Ports On/Off simulataneously!! Otherwise there will be a current flow
// between the pins!
// ===================================================

void switchOnBlue()
{
  PORTC |= ((1<<PINC2) | (1<<PINC3));
}

void switchOffBlue()
{    
  PORTC &= ~((1<<PINC2) | (1<<PINC3));
}

void switchOnRed()
{    
  PORTC |= ((1<<PINC4) | (1<<PINC5));  
}

void switchOffRed()
{
  PORTC &= ~((1<<PINC4) | (1<<PINC5));  
}

void switchOnGreen()
{
    PORTC |= ((1<<PINC0) | (1<<PINC1));  
}

void switchOffGreen()
{   
  PORTC &= ~((1<<PINC0) | (1<<PINC1));  
}

#endif
